<script setup lang="ts">
// @ts-expect-error Types for jmespath are broken
import jmespath from "jmespath";

import type { Study } from "~/lib/types";
import config from "~/lib/config";

const props = defineProps({
  studies: Array<Study>,
});

const currentPage = defineModel("currentPage", {
  type: Number,
  default: 1,
});
</script>

<template>
  <client-only>
    <o-table
      :data="studies"
      striped
      mobile-cards
      paginated
      :per-page="config.list.table.items_per_page"
      v-model:currentPage="currentPage"
    >
      <o-table-column
        v-for="column in config.list.table.columns"
        :field="column.path"
        :label="column.label"
        v-slot:default="props"
      >
        <NuxtLink
          v-if="column.is_link"
          :to="`/studies/${props?.row.id}`"
          :class="{ 'custom-nowrap': column.is_nowrap }"
          >{{ jmespath.search(props?.row, column.path) }}</NuxtLink
        >
        <component
          v-else-if="column.component !== undefined"
          :class="{ 'custom-nowrap': column.is_nowrap }"
          :is="resolveComponent(column.component)"
          :value="jmespath.search(props?.row, column.path)"
        />
        <span v-else :class="{ 'custom-nowrap': column.is_nowrap }">{{
          jmespath.search(props?.row, column.path)
        }}</span>
      </o-table-column>
    </o-table>
  </client-only>
</template>
